<template>
  <div class="tags-view-container">
    <scroll-pane class='tags-view-wrapper'
                 ref='scrollPane'>
      <router-link ref='tag'
                   class="tags-view-item"
                   :class="isActive(tag)?'active':''"
                   v-for="(tag,index) in Array.from(visitedViews)"
                   :to="{path:tag.fullPath,query:tag.query,some:tag.path}"
                   :key="index"
                   @contextmenu.prevent.native="openMenu(tag,$event)">
        {{generateTitle(tag.title)}}
        <!-- v-if="index == Array.from(visitedViews).length -1" -->
        <span class='el-icon-close'
              @click.prevent.stop='closeSelectedTag(tag)'></span>
      </router-link>
    </scroll-pane>
    <ul class='contextmenu'
        v-show="visible"
        :style="{left:left+'px',top:top+'px'}">
      <li @click="closeSelectedTag(selectedTag)">关闭</li>
      <li @click="closeOthersTags">关闭其他</li>
      <li @click="closeAllTags">关闭所有</li>
      <li @click="refresh(selectedTag)">刷新</li>
    </ul>
  </div>
</template>

<script>
import ScrollPane from '@/components/ScrollPane'
import { generateTitle } from '@/utils/i18n'
import { Searchs } from '@/helpers'

export default {
  name: 'TagsView',
  components: { ScrollPane },
  data () {
    return {
      visible: false,
      top: 0,
      left: 0,
      selectedTag: {}
    }
  },
  inject: ['reloads'],
  computed: {
    visitedViews () {
      // console.log(this.$store.state.tagsView.visitedViews)
      return this.$store.state.tagsView.visitedViews
    }
  },
  watch: {
    $route () {
      this.addViewTags()
      this.moveToCurrentTag()
    },
    visible (value) {
      if (value) {
        document.body.addEventListener('click', this.closeMenu)
      } else {
        document.body.removeEventListener('click', this.closeMenu)
      }
    }
  },
  mounted () {
    this.addViewTags()

  },
  methods: {
    // generateTitle by vue-i18n
    generateTitle,
    generateRoute () {
      if (this.$route.path && this.$route.path != '/') {
        return this.$route
      }
      return false
    },
    // || route.name === this.$route.name
    isActive (route) {
      return route.path === this.$route.path
    },
    syncTagViewAndSaveForm() {
      const keys = this.$store.state.tagsView.visitedViews.map(item => item.path)
      const searchs = new Searchs()
      const allSearch = searchs.getSearchs()
      const sks = Object.keys(allSearch)
      for (const item of sks) {
        if (!(keys.includes(item) || keys.includes(allSearch[item].bind))) {
          searchs.removeByKey(item)
        }
      }
    },
    async addViewTags () {
      const route = this.generateRoute()
      if (!route) {
        return false
      }
      // console.log(this.$route)
      await this.$store.dispatch('addVisitedViews', route)
      this.syncTagViewAndSaveForm()
    },
    moveToCurrentTag () {
      const tags = this.$refs['tag']
      this.$nextTick(() => {
        for (const tag of tags) {
          if (tag.path === this.$route.path) {
            this.$refs.scrollPane.moveToTarget(tag.$el)
            break
          }
        }
      })
    },
    closeSelectedTag (view) {
      const searchs = new Searchs()
      searchs.remove(this.$route.path)
      this.$store.dispatch('delVisitedViews', view).then((views) => {
        if (this.isActive(view)) {
          const latestView = views.slice(-1)[0]
          if (latestView) {
            this.$router.push(latestView.fullPath)
          } else {
            this.$router.push('/')
          }
        }
      })
    },
    closeOthersTags () {
      this.$router.push(this.selectedTag.path)
      this.$store.dispatch('delOthersViews', this.selectedTag).then(() => {
        this.moveToCurrentTag()
      })
    },
    closeAllTags () {
      this.$store.dispatch('delAllViews')
      this.$router.push('/')
    },
    openMenu (tag, e) {
      this.visible = true
      this.selectedTag = tag
      this.left = e.clientX - 165
      this.top = e.clientY + 15
    },
    closeMenu () {
      this.visible = false
    },
    async refresh (view) {
      await this.reloads()
    }
  }
}
</script>

<style lang="less" scoped>
.tags-view-container {
  .tags-view-wrapper {
    background: #fff;
    height: 34px;
    border-bottom: 1px solid #d8dce5;
    box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.12), 0 0 3px 0 rgba(0, 0, 0, 0.04);
    .tags-view-item {
      display: inline-block;
      position: relative;
      height: 26px;
      line-height: 26px;
      border: 1px solid #d8dce5;
      color: #495060;
      background: #fff;
      padding: 0 8px;
      font-size: 12px;
      margin-left: 5px;
      margin-top: 4px;
      &:first-of-type {
        margin-left: 15px;
      }
      &.active {
        background-color: #13817a;
        color: #fff;
        border-color: #13817a;
        &::before {
          content: "";
          background: #fff;
          display: inline-block;
          width: 8px;
          height: 8px;
          border-radius: 50%;
          position: relative;
          margin-right: 2px;
        }
      }
    }
  }
  .contextmenu {
    margin: 0;
    background: #fff;
    z-index: 100;
    position: absolute;
    list-style-type: none;
    padding: 5px 0;
    border-radius: 4px;
    font-size: 12px;
    font-weight: 400;
    color: #333;
    box-shadow: 2px 2px 3px 0 rgba(0, 0, 0, 0.3);
    li {
      margin: 0;
      padding: 7px 16px;
      cursor: pointer;
      &:hover {
        background: #eee;
      }
    }
  }
}
//reset element css of el-icon-close
.tags-view-wrapper {
  .tags-view-item {
    .el-icon-close {
      width: 16px;
      height: 16px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);
      transform-origin: 100% 50%;
      &:before {
        transform: scale(0.6);
        display: inline-block;
        vertical-align: -3px;
      }
      &:hover {
        // background-color: #fff;
        color: #b4bccc;
      }
    }
  }
}
</style>
